#include <unistd.h>  
#include <stdio.h>  
#include <iostream>
#include <string.h>
#include "Include/DataType.h"

int GetCheckSum(char *buf)
{
	int sum=0;
	for(int i=0;i<11;i++)
	{
		sum+=buf[i];
	}
	sum=sum&0xFF;
	return sum;
}

int _RSHeaderEx_::Package(unsigned char *data)
{
	int pos=0;
	memcpy(data+pos,&Startcode,sizeof(char));
	pos+=sizeof(char);
	memcpy(data+pos,&Command,sizeof(char));
	pos+=sizeof(char);
	memcpy(data+pos,&Param,sizeof(int));
	pos+=sizeof(int);
	memcpy(data+pos,&Size,sizeof(int));
	pos+=sizeof(int);
	memcpy(data+pos,&Flag,sizeof(char));
	pos+=sizeof(char);
	CheckSum=GetCheckSum((char *)data);
	memcpy(data+pos,&CheckSum,sizeof(char));
	pos+=sizeof(char);
	memcpy(data+pos,&Endcode,sizeof(char));
	pos+=sizeof(char);
#if 1
	if(Size>0)
	{
		memcpy(data+pos,pData,Size-4);
		pos+=(Size-4);
		memcpy(data+pos,&DataCheck,sizeof(int));
		pos+=sizeof(int);
	}
#endif

	return pos;
}


int _RSHeaderEx_::Getlength()
{
	return 13+Size;
}


int  _RSHeaderEx_::GetDataSum(char *buf,int Size)
{
	int sum=0;
	for(int i=0;i<Size;i++)
	{
		sum+=buf[i];
	}
	
	return sum;
}