#ifndef _DATATYPE_H
#define _DATATYPE_H


#define MD_SYS_WP				0x11	//write
#define MD_SYS_SP				0x12	//save
#define MD_SYS_RP				0x13 
#define MD_SYS_STATUS			0x14
#define MD_ENROLL_SCAN		    0x15
#define MD_ENROLL_TMP			0x17
#define MD_VERIFY_SCAN			0x18
#define MD_CONTINUE				0x74
#define MD_CANCEL_OP			0x78
#define MD_ADD_NEW			    0x71
#define MD_DEL_TMP				0x26
#define MD_DEL_ALL_TMP			0x27
#define MD_IDENTIFY_FREE		0x2f
#define MD_DEL_DB				0xF8
#define MD_ENROLL_IMAGE_X	    0x80
#define MD_DELETE_USER			0xF3
#define MD_DEL_ALL_USER			0xF5
#define MD_IDENTIFY_IMAGE_X		0x81
#define MD_SCAN_IMAGE_X			0x83
#define MD_VERIFY_TMP_H_X		0x8E
#define MD_ADD_USER				0xF1
#define MD_READ_USER			0xF2
#define MD_LOAD_USER_X			0xA0
#define MD_LOAD_TMP_X			0xA2
#define MD_READ_TMP_X			0x89
#define MD_DEL_ALOG				0x9E
#define MD_LOAD_LOG_X			0xA4
#define MD_UPDATA				0x72
#define MD_DISCONNECT			0xCC
#define MD_RESET				0xD0
#define MD_SCAN_TEMPLATE		0xFC  //ɨģ
#define MD_VERIFY_IDCARD		0x90  //ָ֤
#define MD_ENROLL_IDCARD		0x88  //ָƵǼ
#define MD_SET_IDCARD 			0x93  //ϴָģ洢ļ


#define SID_MODULE_ID			0x6D
#define SID_MODULE_OPRATE		0x50
#define	SID_TEMP_FORMAT			0x51


#define MD_GET_TIME				0x4B
#define MD_SET_TIME				0x4A


#define MD_SUCESS				0x61
#define MD_SCANSUCESS			0x62


#define THREAD_START			0
#define THREAD_STOP             1
#define OP_ENROLL				2
#define OP_CLEAR				3
#define OP_DELETEUSER           4
#define OP_CONNECT				5
#define OP_DISCONNECT			6
#define OP_VERIFY_SCAN			7
#define OP_SETTING				8
#define OP_GETSETING			9
#define OP_SCANFTEMP			10
#define OP_STOPVERIFYTEMP		11
#define OP_SET_TEMPELATE		12




typedef enum 
{
	Result_OK,
	Result_Error,
	Result_OpenFail,
	Result_SendFail,
	Result_NoReplay,
	Result_NoSuccess,
	Result_EnrollError,
}OP_Result;


typedef enum
{
	Conncet_USB,
	Conncet_Serial,
}ConncetType;


#pragma pack(1)
typedef struct _RSHeader_
{
	char Startcode;
	char Command;
	int Param;
	int Size;
	char Flag;
	char CheckSum;
	char Endcode;
	//void* pData;
} TRSHeader, *PRSHeader;

#pragma pack(1)
typedef struct _RSHeaderEx_
{
	char Startcode;
	char Command;
	int Param;
	int Size;
	char Flag;
	char CheckSum;
	char Endcode;
	void* pData;
	int	 DataCheck;
public:
	int Package(unsigned char *data);
	int Getlength();
	int GetDataSum(char *buf,int Size);
} TRSHeaderEx, *PRSHeaderEx;




#endif