#ifndef THREADPOOL_H
#define THREADPOOL_H
#include "Condition.h"

typedef struct task
{
	void *(*run)(void *args);
	void *arg;
	struct task *next;
}Task_T;


typedef struct ThreadPool
{
	Condition_T Ready;
	Task_T *First;
	Task_T *Last;
	int Counter;//߳
	int Idle;//߳
	int Max_threads;
	int quit;
}ThreadPool_T;


class CThreadPool
{
public:
	CThreadPool(){ ConditionTool=CSingleSon<CCondition*>::GetInstance(); }
	~CThreadPool(){}

public:
	void Thread_Init(ThreadPool_T *Pool,int Threads);

	void Thread_Add_Task(ThreadPool_T *Pool,void *(*run)(void *args),void *arg);

	void Thread_Destroy(ThreadPool_T *Pool);

private:
	CCondition    *ConditionTool;

};












#endif
