#ifndef		USBMODULE_H
#define		USBMODULE_H
#include "DataType.h"





class CUSBModule
{
public:
	CUSBModule();
	~CUSBModule(){};

public:
	int ConnectUSB();

	char *WaitACKData(int timeout);

	int SendCommand(unsigned int Command,int Param,int Size,char Flag,char *databuf,int datalen);

	int SendCommandEx(unsigned int Command,int Param,int Size,char Flag,char *databuf,int datalen);
	
	int Enroll(int Param );

	int StartVerify(int param);

	int SetTemplate();

	int Setting();

	int GetSetting();

	int StartVerifyTemp();

	int CloseDevice();

    void m_RecvData();

	int Unpackege(char *Input,char *Output,PRSHeader cmd);

	bool ClearModule();

	bool DeleteAllUser();

	bool m_ThreadStop;

	bool m_VerifyStop;

	int  m_EnrollID;
private:
		void *m_sensor;    //USB Port
		int  ConnectType;

		char m_ComInBuff[200*1024];
		int  m_InDataLen;
		int  m_Connect_OK;

		char m_ComOutputBuff[200*1024];
		int  m_OutDataLen;
	
		unsigned char TemplateBuff[2048];
		int TemplateSize;
		
};



void *ThreadFun(void *arg);
void *ThreadCheckOperate(void *arg);



typedef struct ThreadDataAndMod
{
	ThreadPool *pThreadPool;
	CUSBModule *pUSBmodules;
}ThreadAndMod_T;

#endif