#include <stdio.h>
#include "include/Condition.h"




int CCondition::Condition_Init(Condition_T *cond)
{
	printf("Condinit\r\n");
	int status;
	if((status=pthread_mutex_init(&cond->pmutex,NULL)))
		return status;

	if((status=pthread_cond_init(&cond->pcond,NULL)));
		return status;

		return 0;
}


int CCondition::Condition_Lock(Condition_T *cond)
{
	return pthread_mutex_lock(&cond->pmutex);
}


int CCondition::Condition_Unlock(Condition_T *cond)
{
	return pthread_mutex_unlock(&cond->pmutex);
}

//wait
int CCondition::Condition_Wait(Condition_T *cond)
{
	return pthread_cond_wait(&cond->pcond,&cond->pmutex);
}


//Fixed time waiting
int CCondition::Condition_Timewait(Condition_T *cond,const struct timespec *abstime)
{
	return pthread_cond_timedwait(&cond->pcond,&cond->pmutex,abstime);
}

int CCondition::Condition_Signal(Condition_T *cond)
{
	return pthread_cond_signal(&cond->pcond);
}


//Wake up all sleep threads
int CCondition::Condition_Broadcast(Condition_T *cond)
{
	return pthread_cond_broadcast(&cond->pcond);
}


int CCondition::Condition_Destroy(Condition_T *cond)
{
	int status;
	if((status=pthread_mutex_destroy(&cond->pmutex)));
		return status;

	if((status=pthread_cond_destroy(&cond->pcond)));
		return status;

		return 0;
}