#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include "include/ThreadPool.h"
#include "include/USBModule.h"
#include "include/DataType.h"
#include "include/SingleSon.h"


int main()
{
	ThreadAndMod_T ThreadAndModedata;
	CUSBModule *USBmodules=new CUSBModule;
	ThreadPool  threadPool={0};
	
	printf("Start Server\n");
	
	ThreadAndModedata.pThreadPool=&threadPool;
	ThreadAndModedata.pUSBmodules=USBmodules;
		
	CSingleSon<CThreadPool>::GetInstance().Thread_Init(&threadPool,10);
	printf("POOL->counter =%d \n",threadPool.Counter);
	CSingleSon<CThreadPool>::GetInstance().Thread_Add_Task(&threadPool,ThreadFun,USBmodules);
	CSingleSon<CThreadPool>::GetInstance().Thread_Add_Task(&threadPool,ThreadCheckOperate,&ThreadAndModedata);




	while(1);


    return  0;

}
