#ifndef CONDITION_H
#define CONDITION_H
#include <pthread.h>
#include "SingleSon.h"

typedef struct Condition
{
	pthread_mutex_t pmutex;
	pthread_cond_t  pcond;
}Condition_T;



class CCondition
{
public:
	CCondition(){};
	~CCondition(){};

public:
	int Condition_Init(Condition_T *cond);
	int Condition_Lock(Condition_T *cond);
	int Condition_Unlock(Condition_T *cond);
	int Condition_Wait(Condition_T *cond);
	int Condition_Timewait(Condition_T *cond,const struct timespec *abstime);
	int Condition_Signal(Condition_T *cond);
	int Condition_Broadcast(Condition_T *cond);
	int Condition_Destroy(Condition_T *cond);

};


#endif

